namespace CMSMicroservice.Application.ClubMembershipCQ.Queries.GetClubMembership;

public class GetClubMembershipQueryValidator : AbstractValidator<GetClubMembershipQuery>
{
    public GetClubMembershipQueryValidator()
    {
        RuleFor(x => x.UserId)
            .GreaterThan(0)
            .WithMessage("شناسه کاربر معتبر نیست");
    }

    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(
            ValidationContext<GetClubMembershipQuery>.CreateWithOptions(
                (GetClubMembershipQuery)model, 
                x => x.IncludeProperties(propertyName)));
        
        if (result.IsValid)
            return Array.Empty<string>();
        
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
